/*
 *  jquery-eclipsefdn-api - v0.0.24
 *  Fetch and display data from various Eclipse Foundation APIs.
 *  https://github.com/EclipseFdn/jquery-eclipsefdn-api
 *
 *  Made by Christopher Guindon
 *  Under MIT License
 *
 *  Thanks to https://github.com/jquery-boilerplate/jquery-boilerplate, MIT License © Zeno Rocha
 */
!function(e,t,a,s){"use strict";var r="eclipseFdnApi",n={apiUrl:"https://api.eclipse.org",gerritUrl:"https://git.eclipse.org/r",eventUrl:"https://events.eclipse.org/data/EclipseEvents.json",forumsUrl:"https://www.eclipse.org/forums",marketplaceUrl:"https://marketplace.eclipse.org",username:"cguindon",currentUser:"",contentPlaceholder:null,errorMsg:'<i class="fa red fa-exclamation-triangle" aria-hidden="true"></i> An unexpected error has occurred.',gerritUserNotFoundMsg:'<h2 class="h3">Outgoing Reviews</h2>There are no outgoing reviews for this user.<h2 class="h3">Incoming Reviews</h2>There are no incoming reviews for this account.',type:"",itemsPerPage:10,accountsUrl:"https://accounts.eclipse.org"};function i(t,a){this.element=t,this.settings=e.extend({},n,a),this._defaults=n,this._name=r,this.init()}e.extend(i.prototype,{init:function(){"string"===e.type(this.settings.type)&&-1!==e.inArray(this.settings.type,["mpFavorites","gerritReviews","recentEvents","forumsMsg","gerritReviewCount","projectsList","errorReports","mailingListSubscription"])&&this[this.settings.type]()},errorReports:function(){var t,s=this,r=s.element,n=!1,i="Unable to retrieve account information required to process this request.",o="Authorization to retrieve error reports was denied.",l=s.settings.apiUrl+"/account/profile/"+s.settings.username,p={clientName:"aeriReports",apiUrl:"https://dev.eclipse.org",completeOnAuthorization:!1,username:s.settings.username,encodeStorage:!0},c="/recommenders/community/aeri/v2/api/v1/reporters/",d="/problems",g={path:"",method:"GET",cid:"aeri_reports",scope:"eclipse_aeri_view_own_report email openid",successCallback:"",errorCallback:function(e){switch(e.status){case 404:u("No submissions found.");break;default:u()}}};function u(t,a){"boolean"!=typeof a&&(a=!1),void 0===t&&(t=s.settings.errorMsg),a&&(t=s.settings.errorMsg+t);var r=e("<p></p>").append(t);e(s.element).append(r)}function h(r,n,i){!function(r,n){void 0===r&&(r=1);void 0===n&&(n=s.settings.itemsPerPage);g.path=c+t+d+"?page="+r+"&size="+n,g.successCallback=function(e){addReportRows(e)},e(a).eclipseFdnIgc.makeRequest(g)}(n,i)}e(a).on("igcAuthFailed",function(e,t){t.clientName===p.clientName&&(u(o),n=!0)}),e(r).eclipseFdnIgc(p),n||e.ajax({url:l,context:s.element}).done(function(l){void 0!==l.mail?(t=l.mail,n?u(o):(g.path=c+t+d+"?page=1&size="+s.settings.itemsPerPage,g.successCallback=function(t,a,n){!function(t){var a=e("<table></table>").attr({width:"100%",class:"table",id:"aeri-reports"}),s=e("<tr></tr>"),n=e("<th></th>");s.append(n.clone().text("Title").attr("width","50%")),s.append(n.clone().text("Status").attr({width:"10%",class:"text-center"})),s.append(n.clone().text("Resolution").attr({width:"10%",class:"text-center"})),s.append(n.clone().text("Reporters").attr({width:"10%",class:"text-center"})),s.append(n.clone().text("Your First Report").attr({width:"20%",class:"text-center"})),a.append(s);var i=e("<div></div>").attr({class:"table-responsive"});i.append(a),e(r).append(i),e.each(t,function(t,s){var r,n=e("<tr></tr>"),i=e("<td></td>"),o=e("<a></a>"),l=e("<ul></ul>"),p=e("<li></li>");o.attr("target","_blank"),e.each(s.links,function(e,t){"problem"===t.rel&&(r=o.clone().attr({href:t.href}).text(t.title)),"submission"===t.rel&&(t.title||(t.title="(No error message)"),l.append(p.clone().append(o.clone().attr({href:t.href}).html("<small>"+t.title+"</small>"))))}),n.append(i.clone().append(r).append(l).attr({class:"ellipsis white-space-normal",style:"max-width:200px;"})),n.append(i.clone().text(s.status).attr("class","text-center")),n.append(i.clone().text(s.resolution).attr("class","text-center"));var c=e("<span></span>").attr("class","badge");c.text(s.numberOfReporters),n.append(i.clone().append(c).attr("class","text-center"));var d=new Date(s.firstReported),g=d.getMonth()<10?"0"+d.getMonth():d.getMonth(),u=d.getDate()<10?"0"+d.getDate():d.getDate(),h=d.getFullYear()+"-"+g+"-"+u;n.append(i.clone().text(h).attr("class","text-center")),a.append(n)})}(t);var i=new s.linkHeaderParser(n.getResponseHeader("Link")),o=i.getLastPageNum();i.getPageSize()!==s.settings.itemsPerPage&&(s.settings.itemsPerPage=i.getPageSize()),e("#aeri-reports").on("fetchPageItemsEvent",h),e("#aeri-reports").data("postsPerPage",s.settings.itemsPerPage),e(r).append(s.getPaginationBar(o*s.settings.itemsPerPage,"aeri-reports"))},e(a).eclipseFdnIgc.makeRequest(g))):u(i,!0)}).fail(function(){u(i,!0)})},projectsList:function(){var t=this,a=this.settings.username,s=this.settings.apiUrl;if(!a&&!api_url)return!1;var r=s+"/account/profile/"+a+"/projects";e.ajax(r,{context:this.element,success:function(a){var s=Object.keys(a).length;if(void 0===s&&(s=0),e(this).children("strong").text(s+t.plurialString(" project",s)),!(t.settings.contentPlaceholder instanceof jQuery))return!1;var r=e(t.settings.contentPlaceholder),n=e("<a></a>");r.append(e("<h2></h2>").addClass("h3").text("Eclipse Projects")),r.append('<p>Projects are the organizational unit for open source development work at the Eclipse Foundation. Projects have developers (committers), source code repositories, build servers, downloads, and other resources. The Eclipse Foundation\'s open source projects are governed by the <a href="https://eclipse.org/projects/dev_process/">Eclipse Development Process</a>.</p>');var i="This user is";if(t.settings.currentUser===t.settings.username&&(i="You are"),0===s)return r.append('<div class="alert alert-warning" role="alert">'+i+" not involved in any Eclipse Projects.</div>"),!1;var o=e("<table></table>").attr({width:"100%",class:"table"}),l=e("<tr></tr>"),p=e("<th></th>"),c=e("<td></td>");l.append(p.clone().text("Project").attr("width","85%")),l.append(p.clone().text("Relation").attr({width:"15%",class:"text-center"})),o.append(l),e.each(a,function(a,s){var r=[],i="",p="";e.each(s,function(e,t){r.push(t.Relation.Description),i=t.ProjectName,p=t.ActiveDate,""!==t.url&&(i=n.clone().attr({href:t.url}).text(i))}),(l=e("<tr></tr>")).append(c.clone().html(i).append("<br/><small>Since: "+t.dateFormat(new Date(p))+"</small>")),l.append(c.clone().text(r.join(", ")).attr("class","text-center")),o.append(l)});var d=e("<div></div>").attr({class:"table-responsive"});d.append(o),r.append(d)},error:function(){e(this).html(t.settings.errorMsg)}})},forumsMsg:function(){var t=this,a=this.settings.username,s=this.settings.apiUrl;if(!a&&!api_url)return!1;var r=s+"/account/profile/"+a+"/forum?page=1&pagesize="+t.settings.itemsPerPage;function n(a){var s=e("#forum-posts");e.each(a.posts,function(r,n){var i={forum_id:n.thread_forum_id,forum_name:n.forum_name,forum_cat_id:n.forum_name,forum_cat_name:n.cat_name,root_subject:n.root_msg_subject,current_user_last_post_timestamp:n.msg_group_post_stamp,current_user_last_post_subject:n.last_user_msg_subject,thread_id:n.msg_thread_id,thread_reply_count:n.thread_replies,thread_views_count:n.thread_views,thread_last_post_date:n.thread_last_post_date,last_message_timestamp:n.last_msg_post_stamp,last_message_poster_id:n.last_msg_poster_id,last_message_poster_alias:n.last_poster_alias,last_message_last_view:n.read_last_view,current_user_id:a.id},o=e("<tr></tr>"),l=e("<td></td>"),p=e("<a></a>"),c=p.clone().attr({href:t.settings.forumsUrl+"/index.php/f/"+i.forum_id+"/"}).text(i.forum_name),d=p.clone().attr({href:t.settings.forumsUrl+"/index.php/i/"+i.forum_cat_id+"/"}).text(i.forum_cat_name),g=e("<small></small>").append("<br/>").append(d).append(" &gt; ").append(c).append(" &gt; ").append(i.root_subject).append("<br>Posted on "+t.dateFormat(new Date(parseInt(1e3*i.current_user_last_post_timestamp)))),u="fa fa-envelope-open-o";t.settings.currentUser===t.settings.username&&i.last_message_last_view<i.thread_last_post_date&&i.last_message_poster_id!==i.current_user_id&&(o.addClass("warning"),u="fa fa-envelope-o"),t.settings.currentUser===t.settings.username&&o.append(l.clone().html('<i class="'+u+'" aria-hidden="true"></i>').attr("class","text-center")),o.append(l.clone().html(p.clone().attr({href:t.settings.forumsUrl+"/index.php/t/"+i.thread_id+"/"}).text(i.current_user_last_post_subject)).append(g)),o.append(l.clone().text(i.thread_reply_count).attr("class","text-center")),o.append(l.clone().text(i.thread_views_count).attr("class","text-center"));var h=e("<small></small>").append(t.dateFormat(new Date(parseInt(1e3*i.last_message_timestamp)))).append("<br/> By: ").append(p.clone().attr({href:t.settings.forumsUrl+"/index.php/sp/"+i.last_message_poster_id+"/"}).text(i.last_message_poster_alias));o.append(l.clone().html(h).attr("class","text-center")),s.append(o)})}function i(r,i,o){!function(r,i){void 0===r&&(r=1);void 0===i&&(i=t.settings.itemsPerPage);var o=s+"/account/profile/"+a+"/forum?page="+r+"&pagesize="+i;e.ajax(o,{context:t.element,success:function(e){n(e)},error:function(){e(this).html(t.settings.errorMsg)}})}(i,o)}e.ajax(r,{context:this.element,success:function(a,s,r){var o=0;if(void 0!==a.posted_msg_count&&void 0!==a.id&&(o=a.posted_msg_count,e(this).attr({href:t.settings.forumsUrl+"/index.php/sp/"+a.id+"/"})),e(this).children("strong").text(o+t.plurialString(" topic",o)),!(t.settings.contentPlaceholder instanceof jQuery))return!1;var l=e(t.settings.contentPlaceholder),p=e("<a></a>");l.append(e("<h2></h2>").addClass("h3").text("Eclipse Forums")),l.append(e("<p></p>").append("The Eclipse forums are your way of communicating with the community of people developing and using Eclipse-based tools hosted at Eclipse.org. Please stick to technical issues - and remember, no confidential information - these are public forums!"));var c=p.clone().attr({href:t.settings.forumsUrl,class:"btn btn-primary btn-sm",style:"display:block"}).html('<i class="fa fa-angle-double-right" aria-hidden="true"></i> More');if(0===a.posts.length)return l.append('<div class="alert alert-warning" role="alert">This user does not have any activities on Eclipse Forums.</div>'),l.append(c),!1;var d=e("<table></table>").attr({width:"100%",class:"table",id:"forum-posts"}),g=e("<tr></tr>"),u=e("<th></th>");t.settings.currentUser===t.settings.username&&g.append(u.clone().attr("width","8%")),g.append(u.clone().text("Topics").attr("width","50%")),g.append(u.clone().text("Replies").attr({width:"8%",class:"text-center"})),g.append(u.clone().text("Views").attr({width:"8%",class:"text-center"})),g.append(u.clone().text("Last message").attr({class:"text-center"})),d.append(g);var h=e("<div></div>").attr({class:"table-responsive"});h.append(d),l.append(h),n(a);var m=new t.linkHeaderParser(r.getResponseHeader("Link")),f=m.getLastPageNum();m.getPageSize()!==t.settings.itemsPerPage&&(t.settings.itemsPerPage=m.getPageSize()),d.on("fetchPageItemsEvent",i),d.data("postsPerPage",t.settings.itemsPerPage),l.append(t.getPaginationBar(f*t.settings.itemsPerPage,"forum-posts"));var v=a.id;c.attr({href:t.settings.forumsUrl+"/index.php/sp/"+v+"/"}),l.append(c)},error:function(){e(this).html(t.settings.errorMsg)}})},mpFavorites:function(){var t=this,a=this.settings.username,s=this.settings.apiUrl;if(!a&&!api_url)return!1;if(t.settings.contentPlaceholder instanceof jQuery){var r=e(t.settings.contentPlaceholder),n=e("<a></a>").attr({href:t.settings.marketplaceUrl+"/user/"+a+"/favorites",class:"btn btn-primary btn-sm",style:"display:block"}).html('<i class="fa fa-angle-double-right" aria-hidden="true"></i> More');r.append(e("<h2></h2>").addClass("h3").text("Eclipse Marketplace Favorites")),r.append(e("<p></p>").append("Eclipse Marketplace is the source for Eclipse-based solutions, products and add-on features. Thousands of developers visit Marketplace on a monthly basis to find new and innovative solutions. Solution providers are encouraged to list their products on Marketplace to gain exposure to the Eclipse developer community."))}var i=s+"/marketplace/favorites?name="+a+"&page=1&pagesize="+t.settings.itemsPerPage;function o(a){var s=t.settings.marketplaceUrl+"/node/"+a+"/api/p";e.ajax(s,{context:t.element,success:function(a){var s=e("#mpfavorites-list");e("node",a).each(function(a,r){var n=e(r),i=n.find("shortdescription").text(),o=r.getAttribute("name"),l=n.find("changed").text(),p=n.find("owner").text(),c="Last Updated on "+t.dateFormat(new Date(parseInt(1e3*l)))+" by "+p,d=r.getAttribute("id"),g=e("#mp-listing-template").clone().removeClass("hidden").removeAttr("id"),u=e("<a></a>"),h=e("category",r),m=t.settings.marketplaceUrl+"/node/"+d,f=n.find("image").text(),v=u.clone().attr({href:m});h.each(function(e,t){var a=u.clone().attr({href:t.getAttribute("url")}).text(t.getAttribute("name"));h.length!==e+1&&a.append(", "),g.find(".content-categories").append(a)}),g.find(".listing-image").attr({href:m,style:"background:url('"+f+"') no-repeat center;"}),g.find(".drag").attr({href:t.settings.marketplaceUrl+"/marketplace-client-intro?mpc_install="+d}),g.find(".listing-title").html(v.clone().text(o)),g.find(".content-teaser").html(i),g.find(".content-last-updated").html(c),s.append(g)})},error:function(){e(this).html(t.settings.errorMsg)}})}function l(r,n,i){!function(r,n){void 0===r&&(r=1);void 0===n&&(n=t.settings.itemsPerPage);var i=s+"/marketplace/favorites?name="+a+"&page="+r+"&pagesize="+n;e.ajax(i,{context:t.element,success:function(t){var a=[];e.each(t.mpc_favorites,function(e,t){a.push(t.content_id)}),o(a.join())},error:function(){e(this).html(t.settings.errorMsg)}})}(n,i)}e.ajax(i,{context:this.element,success:function(a,s,i){if(e(this).children("strong").text(a.result.count+t.plurialString(" favorite",a.result.count)),void 0===r)return!1;var p=[];if(e.each(a.mpc_favorites,function(e,t){p.push(t.content_id)}),0===p.length)return r.append('<div class="alert alert-warning" role="alert">There are no marketplace favorites for this user.</div>'),r.append(n),!1;var c=new t.linkHeaderParser(i.getResponseHeader("Link")),d=c.getLastPageNum();c.getPageSize()!==t.settings.itemsPerPage&&(t.settings.itemsPerPage=c.getPageSize()),r.on("fetchPageItemsEvent",l),r.append('<h3 id="mpc_list_name">'+a.mpc_list_name+"</h3>"),r.append('<div class="row"><div class="col-md-17"><div class="form-item form-type-textfield form-disabled"><label>Favorites URL <a href="#" class="install-user-favorites" data-container="body" data-toggle="popover" data-placement="top" title="" data-original-title="How to install?"><i class="fa fa-question-circle" aria-hidden="true"></i></a> </label><input disabled="true" class="form-control form-text" type="text" value="http://marketplace.eclipse.org/user/'+t.settings.username+'/favorites" size="60" maxlength="128"></div></div><div class="col-md-7 margin-top-25 text-right"><div class="drag_installbutton drag_installbutton_v2 drag-install-favorites"><a href="http://marketplace.eclipse.org/user/'+t.settings.username+'/favorites" class="drag" title="How to install?"><span class="btn btn-default"><i class="fa fa-download orange"></i> Install Favorites</span><div class="tooltip tooltip-below-right"><h3>Drag to Install!</h3>Drag to your running Eclipse<sup>*</sup> workspace to install this favorite list. <br><sup>*</sup>Requires Eclipse Marketplace Client.</div></a></div></div></div>'),r.append('<div id="mpfavorites-list"></div>'),r.find("#mpfavorites-list").data("postsPerPage",t.settings.itemsPerPage),o(p.join()),r.append(t.getPaginationBar(d*t.settings.itemsPerPage,"mpfavorites-list")),r.append(n),e("a.install-user-favorites").on("click",function(e){e.preventDefault()}),e("a.install-user-favorites").popover({html:!0,content:function(){return e("<ol></ol>").addClass("padding-left-20").append("<li>Copy <strong>URL</strong> from textfield.</li>").append("<li>Open Eclipse Marketplace Client (MPC).</li>").append("<li>Open <strong>Favorites</strong> tab.</li>").append("<li>Click on <strong>Import Favorites list</strong>.</li>").append("<li>Paste <strong>URL</strong> in the textfield.</li>")}})},error:function(){e(this).html(t.settings.errorMsg)}})},gerritReviewCount:function(){var t=this,a=this.settings.username,s=this.settings.apiUrl+"/account/profile/"+a+"/gerrit";e.ajax(s,{context:this.element,success:function(a){var s=a.merged_changes_count;e(this).children("strong").text(s+t.plurialString(" review",s)),s>0&&e(this).attr({href:t.settings.gerritUrl+"/#/q/owner:"+t.settings.username})},error:function(){e(this).html(t.settings.errorMsg)}})},mailingListSubscription:function(){var t=this,a=t.settings.username,s=t.settings.currentUser,r=t.settings.currentUserUid,n=t.settings.userCanEditOwnMailingList,i=this.settings.apiUrl;if(!a&&!api_url)return!1;var o=t.element,l=i+"/account/profile/"+a+"/mailing-list";e.ajax(l,{context:this.element,success:function(t){var i=t.mailing_list_subscriptions,l=e("<p></p>"),p=e("<h2></h2>"),c=e("<a></a>"),d=e("<strong></strong>"),g="This user is";s===a&&(g="You are");var u=c.clone().attr({href:"/user/"+r+"/mailing-list",class:"fa fa-pencil","aria-hidden":"true"});if(e(o).append(p.text("Eclipse Mailing Lists ").append(u)),jQuery.isEmptyObject(i))e(o).append(l.clone().text(g+" not subscribed to any Eclipse mailing list."));else{e(o).append(l.clone().text("The Eclipse Mailing lists are another way for you to interact with your favorite Eclipse project.")),e(o).append(l.clone().text("Below is a list of the public mailing lists that "+g.toLowerCase()+" currently  subscribed to at Eclipse.org. When posting emails to our mailing lists, please remember that these lists are public, avoid posting ").append(d.clone().text("personal")).append(" or ").append(d.clone().text("private information")).append(".")),e(o).append(l.clone().text("If you are having trouble using our mailing lists, please contact ").append(c.clone().attr("href","mailto:mailman@eclipse.org").text("mailman@eclipse.org")).append("."));var h=e("<table></table>").attr({width:"100%",class:"table",id:"aeri-reports"}),m=e("<tr></tr>"),f=e("<th></th>");m.append(f.clone().text("Mailing List").attr("width","30%")),m.append(f.clone().text("Description").attr("width","70%")),h.append(m);var v=e("<div></div>").attr({class:"table-responsive"});v.append(h),e(o).append(v),e(o).append(l),e.each(i,function(t,a){var s=e("<tr></tr>"),r=e("<td></td>");s.append(r.clone().append(c.clone().attr("href","/mailing-list/"+a.list_name).text(a.list_name))),s.append(r.clone().append(a.list_description)),h.append(s)})}s===a&&n&&e(o).append(l.clone().append(c.clone().attr({href:"/user/"+r+"/mailing-list",class:"btn btn-primary btn-xs"}).text("Manage your Mailing Lists")))},error:function(){e(this).html(t.settings.errorMsg)}})},gerritReviews:function(){var t=this,a=this.settings.gerritUrl+"/changes/?q=owner:"+this.settings.username+"+status:open&q=reviewer:"+this.settings.username+"+status:open+-owner:"+this.settings.username+"&pp=0";e(this.element).append(e("<h2>Eclipse Gerrit</h2>").addClass("h3")),e(this.element).append("<p>Gerrit is a web based code review system, facilitating online code reviews for projects using the Git version control system.</p>"),function(a){var s=[["gerrit-outgoing",[]],["gerrit-incoming",[]]];e(t.element).on("drawTableEvent",function(){e.each(s,function(a,s){var r="";switch(s[0]){case"gerrit-outgoing":r="Outgoing Reviews";break;case"gerrit-incoming":r="Incoming Reviews"}var n=e("<h4></h4>").addClass("h4").text(r);e(t.element).append(n),0!==s[1].length?(e(t.element).append(function(a,s){var r=e("<table></table>").attr({width:"100%",class:"table",id:a}),n=e("<tr></tr>"),i=e("<th></th>"),o=e("<td></td>");n.append(i.clone().text("Subject").attr("width","70%")),n.append(i.clone().text("Status").attr({width:"18%",class:"text-center"})),n.append(i.clone().text("Updated").attr({width:"12%",class:"text-center"})),r.append(n);var l=e("<a></a>");e.each(s,function(a,s){n=e("<tr></tr>");var i="";!1===s.mergeable&&(i="Merge Conflict",n.addClass("warning"));var p=s.updated.substring(0,s.updated.indexOf(" "));n.append(o.clone().html(l.clone().attr({href:t.settings.gerritUrl+"/"+s._number}).text(s.subject)).append("<br/>"+s.project)),n.append(o.clone().text(i).attr("class","text-center")),n.append(o.clone().text(p).attr("class","text-center")),r.append(n)});var p=e("<div></div>").attr({class:"table-responsive"});return p.append(r),p}(s[0],s[1])),e(t.element).append(t.getPaginationBar(s[1].length,s[0]))):e(t.element).append('<div class="alert alert-warning" role="alert">There are no '+r.toLowerCase()+" for this user.</div>")});var a=e("<a></a>").attr({href:t.settings.gerritUrl+"/#/q/owner:"+t.settings.username,class:"btn btn-primary btn-sm",style:"display:block"}).html('<i class="fa fa-angle-double-right" aria-hidden="true"></i> More');e(t.element).append(a)}),function a(r,n,i){n=void 0!==n?n:100;i=void 0!==i?i:0;r+="&start="+i+"&n="+n;return e.ajax(r,{dataType:"gerrit_XSSI",context:t.element,converters:{"text gerrit_XSSI":function(e){var t=e.substring(e.indexOf("\n")+1);return jQuery.parseJSON(t)}},success:function(o){var l=Object,p=Object;0!==o[0].length&&(e.merge(s[0][1],o[0]),l=o[0][o[0].length-1]),0!==o[1].length&&(e.merge(s[1][1],o[1]),p=o[1][o[1].length-1]),"_more_changes"in l&&!0===l._more_changes||"_more_changes"in p&&!0===p._more_changes?a(r,n,i+n):e(t.element).trigger("drawTableEvent")},error:function(a){400===a.status?e(this).html(t.settings.gerritUserNotFoundMsg):e(this).html(t.settings.errorMsg),!0}})}(a,100,0)}(a)},recentEvents:function(){var t=this;function a(e,t){return e.dateTime-t.dateTime}e.ajax(this.settings.eventUrl,{context:this.element,success:function(s){var r=new Date,n=[];for(var i in s.events)s.events[i].dateTime=new Date(s.events[i].date),s.events[i].dateTime>=r&&n.push(s.events[i]);n.sort(a);var o=e("<ul></ul>").attr({class:"nav",style:"margin:0"});for(var l in n.slice(0,5)){var p=n[l].dateTime,c=t.dateFormat(p),d=e("<a>").attr({href:n[l].infoLink}).html(n[l].title+"<br/><small>"+c+"</small>"),g=e("<li></li>").append(d);o.append(g)}e(this).children(".loading").remove(),e(this).append(o);var u=e("<a>").attr({href:"http://events.eclipse.org",class:"btn btn-simple btn-sm"}).text("more");e(this).append(u)},error:function(){e(this).html(t.settings.errorMsg)}})},plurialString:function(e,t){return t>1&&(e+="s"),e},dateFormat:function(e){var t=e.getFullYear(),a=["January","February","March","April","May","June","July","August","September","October","November","December"][e.getMonth()];return["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"][e.getDay()]+", "+a+" "+e.getDate()+", "+t+" - "+("0"+e.getHours()).slice(-2)+":"+("0"+e.getMinutes()).slice(-2)},linkHeaderParser:function(e){var t=this;if(this.links=0,this.getLastPageNum=function(){return void 0===t.links.last?0:o(t.links.last,"page")},this.getPageSize=function(){if(void 0===t.links.first)return 0;var e=o(t.links.first,"pagesize");return 0===e?o(t.links.first,"size"):e},null!=e){for(var a=e.split(","),s={},r=0;r<a.length;r++){a[r]=a[r].replace("&amp;","&");var n=a[r].split(";");if(!(n.length<2)){var i=n[0].replace(/<(.*)>/,"$1").trim();s[n[1].replace(/rel="(.*)"/,"$1").trim()]=i}}this.links=s}function o(e,t){if(void 0===t||void 0===e)return 0;for(var a=e.substr(e.lastIndexOf("?")+1).split("&"),s=0;s<a.length;s++){var r=a[s].split("=");if(decodeURIComponent(r[0])===t)return decodeURIComponent(r[1])}return 0}},getPaginationBar:function(t,a){var s=this;if(void 0===t&&(t=1),!(t<=0||t<=s.settings.itemsPerPage)){var r=e("<nav></nav>").attr({"arial-label":"Page navigation",id:a+"-pager"}).addClass("text-center"),n=Math.ceil(t/s.settings.itemsPerPage),i=o(n,1,a);return r.append(i),void 0===e("#"+a).data("pageCache")&&function(){var t,r=e("#"+a),i=[];switch(a){case"gerrit-incoming":case"gerrit-outgoing":t="gerrit",i=o(r.find("tr"));break;case"mpfavorites-list":t="mpfav";break;case"forum-posts":case"aeri-reports":t="table",i=o(r.find("tr"));break;default:t="generic"}switch(r.data("pageCache",i),r.data("pageCacheType",t),r.data("pageCacheTotalPages",n),r.on("changePageEvent",p),t){case"gerrit":r.trigger("changePageEvent",[1])}function o(a){var r=0,n=0,i=[],o=[];switch(t){case"gerrit":case"table":o[0]=a[0]}return e.each(a,function(t,a){if(e(a).children().first().is("th"))return!0;r===s.settings.itemsPerPage&&(r=0,o[++n]=i,i=[]),i[r++]=a}),i.length>0&&(o[++n]=i),o}}(),r}function o(t,a,s){var r=e("<li></li>"),n=e("<ul></ul>").addClass("pagination");void 0!==s&&n.attr({"data-eclipseFdnApi-elementID":s});var i,o=!1,p="",c=1,d=t,g=function(){var t=e(this),a=t.attr("data-goto-page"),s=t.parents(".pagination").eq(0).data("eclipsefdnapiElementid");e("#"+s).trigger("changePageEvent",[a])};if(t>9){c=t-8,a<=5?(d=9,c=1):a<=t-4&&(c=a-4,d=a+4),o=!0;var u=e("<span></span>");p=r.clone().append(u.clone().html("...").attr({"aria-hidden":"true"})).addClass("pager-ellipses disabled")}for(1!==a&&(n.append(r.clone().addClass("pager-first").html(l("First","first page",1,"<< first").on("click",g))),n.append(r.clone().html(l("Previous","previous page",a-1,"< previous").on("click",g))),!0===o&&c>1&&n.append(p.clone())),i=c;i<=d;i++){var h=r.clone(),m=l("Page "+parseInt(i),"page "+parseInt(i),i).on("click",g);a===i&&h.addClass("active"),h.html(m),n.append(h)}return a<t&&(!0===o&&d<t&&n.append(p.clone()),n.append(r.clone().html(l("Next","next page",a+1,"next >").on("click",g))),n.append(r.clone().addClass("pager-last").html(l("Last","last page",t,"last >>").on("click",g)))),n}function l(t,a,s,r){return void 0===r&&(r=parseInt(s)),e("<a></a>").attr({"aria-label":t,href:"#",onclick:"return false;",title:"Go to "+a,"data-goto-page":parseInt(s)}).text(r)}function p(t,a){var s=e(t.currentTarget),r=s.data("pageCacheType"),n=s.data("pageCache"),i=s.attr("id"),l=e("#"+i+"-pager"),p=l.data("currentPage");switch(null==p&&(p=1),void 0===a&&(a=1),a=parseInt(a),r){case"gerrit":d();break;default:!function(){if(void 0===n[p]){var t=[];n[p]=[],s.is("table")?t=s.find("tr"):s.is("div")&&(t=s.find(".node")),e.each(t,function(t,a){if(e(a).children().first().is("th"))return!0;n[p].push(a)}),s.data("pageCache",n)}}(),d()}if(p!==a){var c=o(s.data("pageCacheTotalPages"),a,i);l.find("ul").replaceWith(c),l.data("currentPage",a)}function d(){if(s.empty(),void 0===n[a]){var t=[];switch(r){case"mpfav":case"table":t.push(a),t.push(s.data("postsPerPage"))}return s.is("table")&&s.append(n[0]),void s.trigger("fetchPageItemsEvent",t)}s.is("table")&&s.append(n[0]),e.each(n[a],function(e,t){s.append(t)})}}}}),e.fn[r]=function(t){return this.each(function(){e.data(this,"plugin_"+r)||e.data(this,"plugin_"+r,new i(this,t))})}}(jQuery,window,document);
